##
## Python Editor
## by ArcticNightWolf
##

## FC = Following Code
## ignore some comments .. xD

from CvPythonExtensions import * # Extensions rulez
import CvScreenEnums # it's good to know what is our ID
import CvUtil # it could be useful
import ScreenInput # i guess we want to interact with this screen
import PyHelpers # Who wouldn't want helper??

import os  # file/folder handling
import string # strings handling

gc = CyGlobalContext() # every other screen has it, why we shouldn't
ArtFileMgr = CyArtFileMgr() # not sure about this ...


class CvPythonEditorScreen: # well ... i tried to make this working without this line, but it seems like it cannot be done xD
	"A Python code Editor Screen"

	def __init__(self): # Who? What? Where? When?

		# Essentials ######################################

		self.sWidgetPrefix = "PythonEditor"

		self.MANAGER_SCREEN_ID = self.sWidgetPrefix + "MainWindow"
		self.BACKGROUND_ID = self.sWidgetPrefix + "BackgroundImage"
		self.EXIT_ID = self.sWidgetPrefix + "ExitWidget"

		self.VERSION = "004"

		# Constants #######################################

		self.BANNED_FILES = ["CIV4CityLSystem.xml", "CIV4PlotLSystem.xml"]  ##todo: solve multiline commentaries

		self.X_SCREEN = 0
		self.Y_SCREEN = 0
		self.W_SCREEN = 1024
		self.H_SCREEN = 768

		self.BORDER_WIDTH = 2
		self.BUTTON_SIZE = 48
		self.HIGHLIGHT_EXTRA_SIZE = 4

		self.Z_SCREEN = -6.1

		self.Y_TITLE = 8
		self.Z_TEXT = self.Z_SCREEN - 0.2
		self.DZ = -0.2
		self.Z_CONTROLS = self.Z_TEXT

		self.bScreenUp = False

		self.X_EXIT = 980
		self.Y_EXIT = 726

		self.VERSION_X = self.W_SCREEN-10
		self.VERSION_Y = self.Y_TITLE+18

		self.LOCATION_PANEL_X = 30
		self.LOCATION_PANEL_Y = 55
		self.LOCATION_PANEL_W = 970
		self.LOCATION_PANEL_H = 145

		self.CODE_PANEL_X = 30
		self.CODE_PANEL_Y = 205
		self.CODE_PANEL_W = 970
		self.CODE_PANEL_H = 495

		self.CODE_TABLE_X = 42
		self.CODE_TABLE_Y = 242
		self.CODE_TABLE_W = 948
		self.CODE_TABLE_H = 448

		self.CODE_TABLE_LINENUMBERCOLSIZE = 58
		self.CODE_TABLE_CODELINECOLSIZE = self.CODE_TABLE_W - self.CODE_TABLE_LINENUMBERCOLSIZE

		self.LABELD = 90
		self.LABEL01X = 64
		self.LABEL01Y = 90
		self.LABEL02X = 376
		self.LABEL02Y = self.LABEL01Y
		self.LABEL03X = 690
		self.LABEL03Y = self.LABEL01Y
		self.LABEL04X = self.LABEL01X
		self.LABEL04Y = 158

		self.SELECT01X = 60
		self.SELECT01Y = 115
		self.SELECT01W = 285
		self.SELECT02X = 372
		self.SELECT02Y = self.SELECT01Y
		self.SELECT02W = self.SELECT01W
		self.SELECT03X = 686
		self.SELECT03Y = self.SELECT01Y
		self.SELECT03W = self.SELECT01W
		self.SELECT04X = 195
		self.SELECT04Y = 155
		self.SELECT04W = 778

		self.PROGRESSX = 20
		self.PROGRESSY = 710

		# Globals #########################################

		self.lastxml = 0  # position of last xml file in dropdown menu lv2
		self.lastxml2 = 0 # position of last xml file in dropdown menu lv3
		self.lastpy = 0   # position of last py file in dropdown menu lv2
		self.lastpy2 = 0  # position of last py file in dropdown menu lv3

		self.selectedFile = "" # actually selected file
		self.startLineNumbering = 0 # handled by self.examineFile ((very dirty way to handle this, i know :) ))
									# signs on which line is first line of code
									## todo: it probably won't work when showing all definitions from entity
									##		  --  CANNOT  --

		# Names ###########################################

		self.MODNAME = "Orbis"					## todo: find another way to get mod folder name
		self.ASSETFOLDER = "Assets"				## todo: possible case sensitivity issue
		self.PYFOLDER = "python"				## todo: possible case sensitivity issue
		self.PYEXT = ".py"						## todo: possible case sensitivity issue
		self.XMLFOLDER = "XML"					## todo: possible case sensitivity issue
		self.XMLEXT = ".xml"					## todo: possible case sensitivity issue
		self.EOFTEXT = "END OF FILE"
		self.EORTEXT = "END OF REPORT"
		self.FILENAMESIGN = "PyEdScrThisISfileNAMEsign"
		self.FILENAMETEXT = "File: "
		self.TEXTFORMATBEGIN = u"<font=4b>"		# formating of EOFTEXT, EORTEXT and FILENAMETEXT
		self.TEXTFORMATEND = u"</font>"
		self.DEFHIGHBEGIN = u"<font=2b>"		# formating of "def" in python files
		self.DEFHIGHEND = u"</font>"

		self.TEXT_HEADER = "Python code browser"
		self.TEXT_EXIT = "EXIT"
		self.LOCATION_PANEL_LABEL = "Location of code"
		self.CODE_PANEL_LABEL = "Code itself"

		# naming: <LABEL/SELECTION>#LEVEL@OPTION(LV)@OPTION(LV-1)@OPTION(LV-2)...
		# ie: LABEL04abcd = "sdfgh" (((1st posibility of 4th level) of 2nd posibility of 3rd level)
		#							of 3rd posibility of 2nd level) of 4th posibility of 1st level

		self.LABELDEF = "Move along ..."
		self.SELECTDEF = "... nothing to see here"
		self.SELECTNONE = "None"
		self.SELECTALL = " ~ ALL"
		self.SELECTROOT = " ~ ROOT"
		self.SELECTSUMMARY = " ~ SUMMARY"
		self.SELECTNI = " ~~ NOT IMPLEMENTED ~~ "
		self.SELECTDNU = " - don't use this"
		self.BANNED = " BLOCKED FILE"		## todo: solve multiline commentaries

		self.LABEL01 = "Search in ..."
		self.SELECT01a = "Files"
		self.SELECT01b = "Entities"
		self.SELECT01c = "Search"

		# Search in ... Files
		self.LABEL02a =	"Select folder"
		self.SELECT02aa =	"[PY]"
		self.SELECT02ba =	"[XML]"
		# Search in ... Files: [PY] extension
		self.LABEL03aa =	 "Select .py file"
		self.LABEL04aaa =	  "Select definition"
		# Search in ... Files: [XML] extension
		self.LABEL03ba =	 "Select .xml file"
		self.LABEL04aba =	  "Select entity"
		# Search in ... Files: all
		self.LABEL03ca =	 "Select file"
		self.LABEL04aca =	  "Select def\\entity"

		# Search in ... Entities
		self.LABEL02b =   "Select type"
		self.SELECT02ab =	"Units"
		self.LABEL03ab =	   "Select unit"
		self.SELECT02bb =	"Spells"
		self.LABEL03bb =	   "Select spell"
		self.SELECT02cb =	"Promotions"
		self.LABEL03cb =	   "Select promotion"
		self.SELECT02db =	"Buildings"
		self.LABEL03db =	   "Select building"
		self.LABEL03xb =	   "Select entitiy"

		self.LABEL04axb =		"Select category"

		# IDs #############################################

		self.LABEL01ID = "labelAid"
		self.LABEL02ID = "labelBid"
		self.LABEL03ID = "labelCid"
		self.LABEL04ID = "labelDid"
		self.SELECT01ID = "selectAid"
		self.SELECT02ID = "selectBid"
		self.SELECT03ID = "selectCid"
		self.SELECT04ID = "selectDid"

		self.LOCATION_PANEL_ID = "LocationPanelid"
		self.CODE_PANEL_ID = "CodePanelid"
		self.CODETABLE = "CodeTableid"

		self.PROGRESSID = "Progress id"

	def startScreen(self, objUnit): # Everybody on board! GO, GO, GO!
		## todo: open browser on selected unit ((objUnit))
		self.interfaceScreen()

	def getScreen(self): # emm ... where are we ?
		return CyGInterfaceScreen(self.MANAGER_SCREEN_ID, CvScreenEnums.PYTHONEDITOR_SCREEN)

	def hideScreen(self): # What? They killed us !!
		screen = self.getScreen()
		screen.hideScreen()
		return None

	def update(self, fDelta): # Update ... in this case nothing to do
		## todo: add some awesome realtime animation .. xD
		return None

	def handleInput(self, inputClass): # Let's handle input of our cool user
		screen = self.getScreen()
		iNotifyCode = inputClass.getNotifyCode()
		iNotifyClicked = NotifyCode.NOTIFY_CLICKED
		iNotifyChar = NotifyCode.NOTIFY_CHARACTER
		sInputName = inputClass.getFunctionName()

		## todo: add quicksearch thingy

		#self.ntl(self.CODETABLE, sInputName, None)
		# check whether clicked on dropdown menu
		if(sInputName==self.SELECT01ID):
			self.ntl(self.CODETABLE, "lv1", None)
			self.L2Con() # update fellow menues
			self.L3Con()
			self.L4Con()
			self.ctr() # rebuild table
		if(sInputName==self.SELECT02ID):
			self.ntl(self.CODETABLE, "lv2", None)
			self.L3Con() # update fellow menues
			self.L4Con()
			self.ctr() # rebuild table
		if(sInputName==self.SELECT03ID):
			self.ntl(self.CODETABLE, "lv3", None)
			self.L4Con() # update fellow menues
			#self.ctr() # rebuild table
		if(sInputName==self.SELECT04ID):
			self.ntl(self.CODETABLE, "lv4", None)
			# last menu - no fellow menu to update
			#self.ctr() # rebuild table
			None;

		return 0

	def interfaceScreen(self): # Let's draw main window
		screen = self.getScreen()
		if (screen.isActive()):
			return None
		screen.setDimensions(screen.centerX(0), screen.centerY(0), self.W_SCREEN, self.H_SCREEN)
		#screen.setDimensions(self.X_SCREEN, self.Y_SCREEN, self.W_SCREEN, self.H_SCREEN)
		sBackgroundPath = ArtFileMgr.getInterfaceArtInfo("SCREEN_BG_OPAQUE").getPath()
		screen.addDDSGFC(self.BACKGROUND_ID, sBackgroundPath, 0, 0, self.W_SCREEN, self.H_SCREEN, WidgetTypes.WIDGET_GENERAL, -1, -1)
		screen.addPanel( "TopPanel", u"", u"", True, False, 0, 0, self.W_SCREEN, 55, PanelStyles.PANEL_STYLE_TOPBAR )
		screen.addPanel( "BottomPanel", u"", u"", True, False, 0, 713, self.W_SCREEN, 55, PanelStyles.PANEL_STYLE_BOTTOMBAR )

		screen.setRenderInterfaceOnly(True)
		screen.showScreen(PopupStates.POPUPSTATE_IMMEDIATE, False)
		screen.showWindowBackground(False)

		# Header...
		screen.setLabel( "Header", "Background", u"<font=4b>"+self.TEXT_HEADER+"</font>", CvUtil.FONT_CENTER_JUSTIFY, self.X_SCREEN+(self.W_SCREEN/2), self.Y_TITLE, self.Z_TEXT, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1)
		screen.setLabel( "Author", "Background", u"<font=2i>by ArcticNightWolf; Ver#"+self.VERSION+"</font>", CvUtil.FONT_RIGHT_JUSTIFY, self.VERSION_X, self.VERSION_Y, self.Z_TEXT, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1)
		# Exit button
		screen.setText( self.EXIT_ID , "Background", u"<font=4>"+self.TEXT_EXIT+"</font>", CvUtil.FONT_CENTER_JUSTIFY, self.X_EXIT, self.Y_EXIT, self.Z_TEXT, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_CLOSE_SCREEN, 1, 0)

		screen.addPanel(self.LOCATION_PANEL_ID, self.LOCATION_PANEL_LABEL, "", False, False, self.LOCATION_PANEL_X, self.LOCATION_PANEL_Y, self.LOCATION_PANEL_W, self.LOCATION_PANEL_H, PanelStyles.PANEL_STYLE_MAIN)

		self.level01Controller();
		self.level02Controller();
		self.level03Controller();
		self.level04Controller();

		self.codeTableReload()


	def L1Con(self): # > level01Controller
		self.level01Controller()

	def level01Controller(self): # Label and initialization & building list
		screen = self.getScreen()
		labID = self.LABEL01ID
		selID = self.SELECT01ID
		panID = self.LOCATION_PANEL_ID

		screen.deleteWidget(labID)
		screen.setText(labID, panID, self.LABEL01, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL01X, self.LABEL01Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)

		screen.deleteWidget(selID)
		screen.addDropDownBoxGFC(selID, self.SELECT01X, self.SELECT01Y, self.SELECT01W, WidgetTypes.WIDGET_GENERAL, -1, -1, FontTypes.GAME_FONT)
		screen.addPullDownString(selID, self.SELECTNONE, 0, 0, False )
		screen.addPullDownString(selID, self.SELECT01a, 1, 1, False ) # >> Files
		screen.addPullDownString(selID, self.SELECT01b, 2, 2, False ) # >> Entities
		screen.addPullDownString(selID, self.SELECT01c, 3, 3, False ) # >> Search

	def L2Con(self): # > level02Controller
		self.level02Controller()

	def level02Controller(self): # Label and list initialization
		screen = self.getScreen()
		labID = self.LABEL02ID
		selID = self.SELECT02ID
		panID = self.LOCATION_PANEL_ID
		lv1ID = self.SELECT01ID
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item

		screen.deleteWidget(labID)

		# Dropdown caption

		if (iLv1==0): # >> None
			screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL02X, self.LABEL02Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif (iLv1==1): # >> Files
			screen.setText( labID, panID, self.LABEL02a, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL02X, self.LABEL02Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif (iLv1==2): # >> Entities
			screen.setText( labID, panID, self.LABEL02b, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL02X, self.LABEL02Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif (iLv1==3): # >> Search
			None;

		# Dropdown itself and items

		screen.deleteWidget(selID)
		screen.addDropDownBoxGFC(selID, self.SELECT02X, self.SELECT02Y, self.SELECT02W, WidgetTypes.WIDGET_GENERAL, -1, -1, FontTypes.GAME_FONT)
		self.buildLevel02List()
		#screen.addPullDownString(selID, self.SELECTDEF, 1, 1, False )

	def buildLevel02List(self): # Building list
		# builds level02 dropdown menu list
		screen = self.getScreen()
		selID = self.SELECT02ID
		lv1ID = self.SELECT01ID
		self.lastxml = 0
		self.lastpy = 0
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		#self.ntl(self.CODETABLE, "before if sq", None)
		if (iLv1==0): # >> None
			#self.ntl(self.CODETABLE, "iLv1 == 0", None)
			self.apds(selID, self.SELECTDEF, 0)
		elif (iLv1==1): # >> Files
			#self.ntl(self.CODETABLE, "iLv1 == 1", None)
			self.apds(selID, self.SELECTNONE, 0)
			iCountItem = 2
			# find directories in python folder
			self.apds(selID, self.SELECT02aa+self.SELECTROOT, 1) # root of python folder
			currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
			#self.ntl(self.CODETABLE, currFolder, None)
			fileList = os.listdir(currFolder)
			for fFilename in fileList:
				if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
					self.apds(selID, self.SELECT02aa+fFilename,iCountItem) # yes! so, add it to the list
					iCountItem+=1
					#self.ntl(self.CODETABLE, fFilename, None)
			self.apds(selID, self.SELECT02aa+self.SELECTALL, iCountItem) # all python folders
			self.lastpy = iCountItem
			iCountItem+=1
			# find directories in XML folder
			self.apds(selID, self.SELECT02ba+self.SELECTROOT, iCountItem) # root of XML folder
			currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
			#self.ntl(self.CODETABLE, currFolder, None)
			fileList = os.listdir(currFolder)
			for fFilename in fileList:
				if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
					self.apds(selID, self.SELECT02ba+fFilename,iCountItem) # yes! so, add it to the list
					iCountItem+=1
					#self.ntl(self.CODETABLE, fFilename, None)
			self.apds(selID, self.SELECT02ba+self.SELECTALL, iCountItem) # all XML folders
			self.lastxml = iCountItem+1
			iCountItem+=1
			# there we go!
			#self.ntl(self.CODETABLE, "end of iLv1==1", None)
			self.apds(selID, self.SELECTALL, iCountItem)
		elif (iLv1==2): # >> Entities
			self.apds(selID, self.SELECTNONE, 0)
			self.apds(selID, self.SELECT02ab, 1)
			self.apds(selID, self.SELECT02bb, 2)
			self.apds(selID, self.SELECT02cb, 3)
			self.apds(selID, self.SELECT02db, 4)
			self.apds(selID, self.SELECTALL,  5)

	def L3Con(self): # > level03Controller
		self.level03Controller()

	def level03Controller(self): # Label and list initialization
		screen = self.getScreen()
		labID = self.LABEL03ID
		selID = self.SELECT03ID
		panID = self.LOCATION_PANEL_ID
		lv1ID = self.SELECT01ID
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		lv2ID = self.SELECT02ID
		iLv2 = screen.getSelectedPullDownID(lv2ID) # get level02 menu item

		# Dropdown caption

		screen.deleteWidget(labID)
		if(iLv1==0): # > None
			screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif(iLv1==1): # > Files
			if(iLv2==0):  # > None
				screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			elif(iLv2<(self.lastpy+1)): # > Python files
				screen.setText( labID, panID, self.LABEL03aa, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			elif(iLv2<(self.lastxml+1)): # > XML files
				screen.setText( labID, panID, self.LABEL03ba, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			else: # > All files
				screen.setText( labID, panID, self.LABEL03ca, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif(iLv1==2): # > Entities
			if(iLv2==0): # > None
				screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==1): # > Units
				screen.setText( labID, panID, self.LABEL03ab, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==2): # > Spells
				screen.setText( labID, panID, self.LABEL03bb, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==3): # > Promotions
				screen.setText( labID, panID, self.LABEL03cb, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==4): # > Buildings
				screen.setText( labID, panID, self.LABEL03db, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==5): # > Effects
				screen.setText( labID, panID, self.LABEL03eb, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			if(iLv2==6): # > All
				screen.setText( labID, panID, self.LABEL03xb, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL03X, self.LABEL03Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)

		# Dropdown itself and items

		screen.deleteWidget(selID)
		screen.addDropDownBoxGFC(selID, self.SELECT03X, self.SELECT03Y, self.SELECT03W, WidgetTypes.WIDGET_GENERAL, -1, -1, FontTypes.GAME_FONT)
		self.buildLevel03List()
		#screen.addPullDownString(selID, self.SELECTDEF, 1, 1, False )

	def buildLevel03List(self): # Building list
		# builds level02 dropdown menu list
		screen = self.getScreen()
		selID = self.SELECT03ID
		lv1ID = self.SELECT01ID
		lv2ID = self.SELECT02ID

		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		iLv2 = screen.getSelectedPullDownID(lv2ID) # get level02 menu item

		iCountItem = 1
		#self.ntl(self.CODETABLE, "before if sq", None)
		if (iLv1==0): # >> None
			#self.ntl(self.CODETABLE, "iLv1 == 0", None)
			self.apds(selID, self.SELECTDEF, 0)
		elif (iLv1==1): # >> Files
			if (iLv2==0): # >> None
				self.apds(selID, self.SELECTDEF, 0)
			elif (iLv2<(self.lastpy+1)): # >> Python
				self.apds(selID, self.SELECTNONE, 0)
				if (iLv2==1): # >> Root
					# load root py files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1
				elif (iLv2==self.lastpy): # >> All
					# load all py files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-3):]
								if (f2Ext == self.PYEXT): # is this filename python file ??
									if (self.applyExcludeList(f2Filename)==None):
										f2Filename=f2Filename + self.BANNED
									self.apds(selID, f2Filename+" ("+fFilename+")",iCountItem) # yes! so, add it to the list
									iCountItem += 1

				else: # >> Regular folder
					# load py files from folder
					iCountItem = 1
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							iCountItem += 1
							if (iCountItem == iLv2):
								fDirectory = fFilename
								break;
					currFolder = os.path.join(currFolder,fDirectory)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1
				self.apds(selID, self.SELECTALL, iCountItem)
			elif (iLv2<(self.lastxml+1)): # >> XML
				self.apds(selID, self.SELECTNONE, 0)
				if (iLv2==self.lastpy+1): # >> Root
					# load root xml files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1

				elif (iLv2==self.lastxml): # >> All
					# load all xml files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-4):]
								if (f2Ext == self.XMLEXT): # is this filename XML file ??
									if (self.applyExcludeList(f2Filename)==None):
										f2Filename=f2Filename + self.BANNED
									self.apds(selID, f2Filename+" ("+fFilename+")",iCountItem) # yes! so, add it to the list
									iCountItem += 1

				else: # >> Regular folder
					# load xml files from folder
					iCountItem = 1
					iSearchFor = iLv2 - self.lastpy
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					#self.ntl(self.CODETABLE, "(iC)"+str(iCountItem)+"; (iS)"+str(iSearchFor), None)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, str(iCountItem)+": "+fFilename, None)
							iCountItem += 1
							if (iCountItem == iSearchFor):
								#self.ntl(self.CODETABLE, "+1 is searched for", None)
								fDirectory = fFilename
								break;
					curr2Folder = os.path.join(currFolder,fDirectory)
					currFolder = curr2Folder
					#self.ntl(self.CODETABLE, currFolder, None)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						#self.ntl(self.CODETABLE, "> "+fFilename, None)
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename python file ??
							if (self.applyExcludeList(fFilename)==None):
								fFilename=fFilename + self.BANNED
							self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
							iCountItem += 1

				self.apds(selID, self.SELECTALL, iCountItem)
			else: # >> All
				self.apds(selID, self.SELECTNONE, 0)
				# load ALL XML and py files
				# load all py files first
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-3):]
					if (fExt == self.PYEXT): # is this filename python file ??
						if (self.applyExcludeList(fFilename)==None):
							fFilename=fFilename + self.BANNED
						self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-3):]
							if (f2Ext == self.PYEXT): # is this filename python file ??
								if (self.applyExcludeList(f2Filename)==None):
									f2Filename=f2Filename + self.BANNED
								self.apds(selID, f2Filename+" ("+fFilename+")",iCountItem) # yes! so, add it to the list
								iCountItem += 1
				self.lastpy2 = iCountItem
				# load all xml files now
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-4):]
					if (fExt == self.XMLEXT): # is this filename XML file ??
						if (self.applyExcludeList(fFilename)==None):
							fFilename=fFilename + self.BANNED
						self.apds(selID, fFilename,iCountItem) # yes! so, add it to the list
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-4):]
							if (f2Ext == self.XMLEXT): # is this filename XML file ??
								if (self.applyExcludeList(f2Filename)==None):
									f2Filename=f2Filename + self.BANNED
								self.apds(selID, f2Filename+" ("+fFilename+")",iCountItem) # yes! so, add it to the list
								iCountItem += 1
				self.lastxml2 = iCountItem
				self.apds(selID, self.SELECTALL+self.SELECTDNU, iCountItem) # << this option is gonna be crazy
		elif (iLv1==2): # >> Entities
			if(iLv2==0): # > None
				self.apds(selID, self.SELECTDEF, 0)
			else:
				#self.apds(selID, self.SELECTNI, 0)
				#return 0 # *** dont go further in this block!
				self.apds(selID, self.SELECTNONE, 0)
				if(iLv2==1): # > Units
					# Load all units
					for i in range(gc.getNumUnitClassInfos()):
						#list.asppend(gc.getUnitInfo(i))
						self.ntl(self.CODETABLE, gc.getUnitInfo(i).getDescription(), None)
						self.apds(selID, gc.getUnitInfo(i).getDescription(), iCountItem)
						iCountItem += 1

				elif(iLv2==2): # > Spells
					# Load all spells
					for i in range(gc.getNumSpellInfos()):
						#list.asppend(gc.getUnitInfo(i))
						self.ntl(self.CODETABLE, gc.getSpellInfo(i).getDescription(), None)
						self.apds(selID, gc.getSpellInfo(i).getDescription(), iCountItem)
						iCountItem += 1
				elif(iLv2==3): # > Promotions
					# Load all promotions
					for i in range(gc.getNumPromotionInfos()):
						#list.asppend(gc.getUnitInfo(i))
						self.ntl(self.CODETABLE, gc.getPromotionInfo(i).getDescription(), None)
						self.apds(selID, gc.getPromotionInfo(i).getDescription(), iCountItem)
						iCountItem += 1
				elif(iLv2==4): # > Buildings
					# Load all buildings
					for i in range(gc.getNumBuildingInfos()):
						#list.asppend(gc.getUnitInfo(i))
						self.ntl(self.CODETABLE, gc.getBuildingInfo(i).getDescription(), None)
						self.apds(selID, gc.getBuildingInfo(i).getDescription(), iCountItem)
						iCountItem += 1
				elif(iLv2==5): # > All
					# Load all
					None;
				self.apds(selID, self.SELECTALL+self.SELECTDNU, iCountItem) # << this option is gonna be crazy

	def L4Con(self): # > level04Controller
		self.level04Controller()

	def level04Controller(self): # Label and list initialization
		screen = self.getScreen()
		labID = self.LABEL04ID
		selID = self.SELECT04ID
		panID = self.LOCATION_PANEL_ID
		lv1ID = self.SELECT01ID
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		lv2ID = self.SELECT02ID
		iLv2 = screen.getSelectedPullDownID(lv2ID) # get level02 menu item
		lv3ID = self.SELECT03ID
		iLv3 = screen.getSelectedPullDownID(lv3ID) # get level03 menu item

		# dropdown caption

		screen.deleteWidget(labID)

		if (iLv1==0): # >> None
			screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif (iLv1==1): # >> File
			if (iLv2==0): # >> None
				screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			elif(iLv2<(self.lastpy+1)): # >> PY
				if (iLv3!=0):
					screen.setText( labID, panID, self.LABEL04aaa, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				else:
					screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			elif(iLv2<(self.lastxml+1)): # >> XML
				if (iLv3!=0):
					screen.setText( labID, panID, self.LABEL04aba, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				else:
					screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			else: # >> ALL
				if(iLv3==0): # >> None
					screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				elif(iLv3<(self.lastpy2)): # >> PY
					screen.setText( labID, panID, self.LABEL04aaa, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				elif(iLv3<(self.lastxml2)): # >> XML
					screen.setText( labID, panID, self.LABEL04aba, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				else: # >> ALL
					screen.setText( labID, panID, self.LABEL04aca, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
		elif (iLv1==2): # >> Entity
			if (iLv2!=0): # >> Entity group selected
				if (iLv3!=0): # >> Entity is selected
					screen.setText( labID, panID, self.LABEL04axb, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
				else:
					screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)
			else:
				screen.setText( labID, panID, self.LABELDEF, CvUtil.FONT_LEFT_JUSTIFY, self.LABEL04X, self.LABEL04Y, self.LABELD, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, 0, -1)

		screen.deleteWidget(selID)
		screen.addDropDownBoxGFC(selID, self.SELECT04X, self.SELECT04Y, self.SELECT04W, WidgetTypes.WIDGET_GENERAL, -1, -1, FontTypes.GAME_FONT)
		self.buildLevel04List()
		#screen.addPullDownString(selID, self.SELECTDEF, 1, 1, False )

	def buildLevel04List(self): # Building list
		screen = self.getScreen()
		selID = self.SELECT04ID
		lv1ID = self.SELECT01ID
		lv2ID = self.SELECT02ID
		lv3ID = self.SELECT03ID
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		iLv2 = screen.getSelectedPullDownID(lv2ID) # get level02 menu item
		iLv3 = screen.getSelectedPullDownID(lv3ID) # get level03 menu item

		iCountItem = 1
		fExamine = None
		fList = []


		#self.ntl(self.CODETABLE, "before if sq", None)
		if (iLv1==0): # >> None
			self.ntl(self.CODETABLE, "iLv1 == 0", None)
			self.apds(selID, self.SELECTDEF, 0)
		elif (iLv2==0): # >> None
			self.ntl(self.CODETABLE, "iLv2 == 0", None)
			self.apds(selID, self.SELECTDEF, 0)
		elif (iLv3==0): # >> None
			self.ntl(self.CODETABLE, "iLv3 == 0", None)
			self.apds(selID, self.SELECTDEF, 0)
		elif (iLv1==1): # >> Files
			if (iLv2<(self.lastpy+1)): # >> Python
				if (iLv2==1): # >> Root
					# load root py files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if ((iCountItem) == iLv3): # examine all
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
				elif (iLv2==self.lastpy): # >> All
					# load all py files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-3):]
								if (f2Ext == self.PYEXT): # is this filename python file ??
									if (iCountItem == iLv3):
										fExamine = os.path.join(curr2Folder, f2Filename)
									iCountItem += 1
					if ((iCountItem) == iLv3): # examine all
						# load all py files
						# root files first
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
						# now folder by folder
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, fFilename ,None)
								f2Filename = fFilename
								curr2Folder = os.path.join(currFolder,f2Filename)
								file2List = os.listdir(curr2Folder)
								for f2Filename in file2List:
									f2Ext = f2Filename[(len(f2Filename)-3):]
									if (f2Ext == self.PYEXT): # is this filename python file ??
										fList.append(os.path.join(curr2Folder, f2Filename))
				else: # >> Regular folder
					# load py files from folder
					iCountItem = 1
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							iCountItem += 1
							if (iCountItem == iLv2):
								fDirectory = fFilename
								break;
					currFolder = os.path.join(currFolder,fDirectory)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder, fFilename)
							iCountItem += 1
					if (iCountItem==iLv3): # examine all
						iCountItem = 1
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								iCountItem += 1
								if (iCountItem == iLv2):
									fDirectory = fFilename
									break;
						currFolder = os.path.join(currFolder,fDirectory)
						fileList = os.listdir(currFolder)
						iCountItem = 1
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder, fFilename))
			elif (iLv2<(self.lastxml+1)): # >> XML
				if (iLv2==self.lastpy+1): # >> Root
					# load root xml files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if (iCountItem == iLv3): # examine all
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename XML file ??
								fList.append(os.path.join(currFolder,fFilename))
				elif (iLv2==self.lastxml): # >> All
					# load all xml files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-4):]
								if (f2Ext == self.XMLEXT): # is this filename XML file ??
									if (iCountItem == iLv3):
										fExamine = os.path.join(curr2Folder,f2Filename)
									iCountItem += 1
					if (iCountItem == iLv3):
						# load all xml files
						# root files first
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename XML file ??
								fList.append(os.path.join(currFolder,fFilename))
						# now folder by folder
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, fFilename ,None)
								f2Filename = fFilename
								curr2Folder = os.path.join(currFolder,f2Filename)
								file2List = os.listdir(curr2Folder)
								for f2Filename in file2List:
									f2Ext = f2Filename[(len(f2Filename)-4):]
									if (f2Ext == self.XMLEXT): # is this filename XML file ??
										fList.append(os.path.join(curr2Folder,f2Filename))

				else: # >> Regular folder
					# load xml files from folder
					iCountItem = 1
					iSearchFor = iLv2 - self.lastpy
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					#self.ntl(self.CODETABLE, "(iC)"+str(iCountItem)+"; (iS)"+str(iSearchFor), None)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, str(iCountItem)+": "+fFilename, None)
							iCountItem += 1
							if (iCountItem == iSearchFor):
								#self.ntl(self.CODETABLE, "+1 is searched for", None)
								fDirectory = fFilename
								break;
					curr2Folder = os.path.join(currFolder,fDirectory)
					currFolder = curr2Folder
					#self.ntl(self.CODETABLE, currFolder, None)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						#self.ntl(self.CODETABLE, "> "+fFilename, None)
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if (iCountItem == iLv3): # examine all
						iCountItem = 1
						iSearchFor = iLv2 - self.lastpy
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						#self.ntl(self.CODETABLE, "(iC)"+str(iCountItem)+"; (iS)"+str(iSearchFor), None)
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, str(iCountItem)+": "+fFilename, None)
								iCountItem += 1
								if (iCountItem == iSearchFor):
									#self.ntl(self.CODETABLE, "+1 is searched for", None)
									fDirectory = fFilename
									break;
						curr2Folder = os.path.join(currFolder,fDirectory)
						currFolder = curr2Folder
						#self.ntl(self.CODETABLE, currFolder, None)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							#self.ntl(self.CODETABLE, "> "+fFilename, None)
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
			else: # >> All
				# load ALL XML and py files
				# load all py files first
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-3):]
					if (fExt == self.PYEXT): # is this filename python file ??
						if (iCountItem == iLv3):
							fExamine = os.path.join(currFolder,fFilename)
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-3):]
							if (f2Ext == self.PYEXT): # is this filename python file ??
								if (iCountItem == iLv3):
									fExamine = os.path.join(curr2Folder,f2Filename)
								iCountItem += 1
				self.lastpy2 = iCountItem
				# load all xml files now
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-4):]
					if (fExt == self.XMLEXT): # is this filename XML file ??
						if (iCountItem == iLv3):
							fExamine = os.path.join(currFolder,fFilename)
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-4):]
							if (f2Ext == self.XMLEXT): # is this filename XML file ??
								if (iCountItem == iLv3):
									fExamine = os.path.join(curr2Folder,f2Filename)
								iCountItem += 1
				self.lastxml2 = iCountItem
				if (iCountItem==iLv3):
					# load ALL XML and py files
					# load all py files first
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							fList.append(os.path.join(currFolder,fFilename))
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-3):]
								if (f2Ext == self.PYEXT): # is this filename python file ??
									fList.append(os.path.join(curr2Folder,f2Filename))
									iCountItem += 1
					# load all xml files now
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							fList.append(os.path.join(currFolder,fFilename))
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-4):]
								if (f2Ext == self.XMLEXT): # is this filename XML file ??
									fList.append(os.path.join(curr2Folder,f2Filename))
									iCountItem += 1
		elif (iLv1==2): # >> Entities
			if(iLv2==0): # > None
				self.apds(selID, self.SELECTDEF, 0)
			else:
				self.apds(selID, self.SELECTNI, 0)
				return 0 # *** dont go further in this block!

		completeList = []
		tempList = []
		self.selectedFile = ""
		if (iLv1==1):
			if (fList==[]):
				self.ntl(self.CODETABLE, "fList is empty", None)
				None;
			else:
				self.ntl(self.CODETABLE, "fList:", None)
				for mItem in fList:
					if (self.applyExcludeList(mItem)!=None):
						self.ntl(self.CODETABLE, mItem, None)
						tempList = self.examineFile(mItem, self.getSeparator(mItem), -1)
						for mItem2 in tempList:
							completeList.append(mItem2)
			if (fExamine!=None):
				self.selectedFile = fExamine
				if (self.applyExcludeList(fExamine)!=None):
					completeList = self.examineFile(fExamine, self.getSeparator(fExamine), -1)
			else:
				None;
			iCountItem = 2
			self.apds(selID, self.SELECTNONE, 0)
			self.apds(selID, self.SELECTSUMMARY, 1)
			for mItem in completeList:
				self.ntl(self.CODETABLE, mItem, None)
				self.apds(selID, mItem, iCountItem)
				iCountItem += 1
			self.apds(selID, self.SELECTALL, iCountItem)
		elif (iLv1==2):
			self.apds(selID, self.SELECTNONE, 0)
			self.apds(selID, self.SELECTSUMMARY, 1)
			iCountItem = 2
			# search everywhere for TXT_DEF and Description
			None;
			# locate pyReq and pyResult

	def applyExcludeList(self, szFile): # PEOPLE WHO MAKE MULTILINE COMMENTARY IN XML SHOULD DIE! :D
		szFile2 = szFile[(self.getPositionLastOccur(szFile, "\\")):]
		for mFile in self.BANNED_FILES:
			if (szFile2==mFile):
				return None
		return szFile

	def getSeparator(self, szFile): # What word separates definitions ?
		if (szFile == None):
			return None
		if(self.fileExt(szFile)==self.PYEXT):
			return "def "
		bNextNextOne = false
		bNextOne = false
		self.ntl(self.CODETABLE, "[debug] gS: "+szFile, None)
		frFile = open(szFile, "r")
		linesFile = frFile.readlines()
		tagAbove = "##-1"
		#self.ntl(self.CODETABLE, "gS, preFOR", None)
		for actualLine in linesFile:
			if ((actualLine[:2] != "<?")and(actualLine[:2] != "<!")):
				while ((actualLine[0]==" ")or(actualLine[0]=="	")):
					actualLine = actualLine[1:]
				if (tagAbove == "##-1"):
					tagAbove = actualLine
				else:
					iPos = string.find(actualLine, ">")
					if (actualLine[iPos+1]!="<"):
						if (actualLine[iPos+1]!="\n"):
							if (actualLine[iPos+1]!="\t"):
								self.ntl(self.CODETABLE, "[debug] gS: >> "+self.handleTagBrace(tagAbove), None)
								return tagAbove
					tagAbove = actualLine
				#self.ntl(self.CODETABLE, "gS, is regular ("+actualLine+")", None)
				#while ((actualLine[1]==" ")or(actualLine[1]=="	")):
				#	actualLine = actualLine[1:]
				#
				#if (bNextOne == True):
				#	self.ntl(self.CODETABLE, "gS, Separator: <!-- "+actualLine+" -->", None)
				#	return actualLine
				#if (bNextNextOne == True):
				#	bNextNextOne = False
				#	bNextOne = True
				#	self.ntl(self.CODETABLE, "no", None)
				#if (string.find(actualLine, "<Civ4") != -1):
				#	self.ntl(self.CODETABLE, "gS, .. <Civ4 found", None)
				#	bNextNextOne = True
				#	self.ntl(self.CODETABLE, "nno", None)
				if (string.find(actualLine, "<Schema") != -1):
					return "<Schema"
				#	bNextOne = True
		self.ntl(self.CODETABLE, "getSeparator: warning!", None)
		frFile.close()
		return None

	def fileExt(self, szFile): # Get extension of that file
		if (szFile == None):
			return None
		if ((szFile[(len(szFile)-3):])==self.PYEXT):
			return self.PYEXT
		if ((szFile[(len(szFile)-4):])==self.XMLEXT):
			return self.XMLEXT

	def getPositionLastOccur(self, szString, szSubString): # Get last occurence of symbol
		iLastOcc = -1
		try:
			szStr2 = szString
			bBeenThere = false
			if (szStr2 == ""):
				return -1
			if (szSubString == ""):
				return -1
			while (string.find(szStr2, szSubString)!=-1):
				bBeenThere = true
				iLastOcc = string.find(szStr2, szSubString)
				szStr2 = szStr2[(iLastOcc+1):]
			if (bBeenThere == true):
				return (len(szString)-len(szStr2))
			else:
				return -1
		except:
			return -1
	def examineFile(self, szFile, szSeparator, iReturnOccur): # Look to file and return specific definition
		# iReturnOccur: -1 = only separators, 0 = header, 1 = first Separator -> second Separator, n+1 = whole file
		# Returns list
		if (szFile == None):
			return None;
		frFile = open(szFile, "r")
		iRet = iReturnOccur
		iActualRow = 0
		mList = []
		linesFile = frFile.readlines()
		frFile.close()
		bAppendNext = False
		iCurrentRound = 0
		self.startLineNumbering = 0
		if (iRet==0):
			mList.append(self.FILENAMESIGN+szFile[self.getPositionLastOccur(szFile, "\\"):])
			bDirect = True
			bAll = False
		elif (iRet==-1):
			mList.append(szFile[(self.getPositionLastOccur(szFile, "\\")):]+" header")
			fExt = self.fileExt(szFile)
			bAll = False
			bDirect = False
		else:
			bDirect = False
			bAll = True
			mList.append(self.FILENAMESIGN+szFile[self.getPositionLastOccur(szFile, "\\"):])
		for actualLine in linesFile:
			iActualRow+=1
			if (bAppendNext):
				bAppendNext = False
				while ((actualLine[0]==" ")or(actualLine[0]=="	")):
					actualLine = actualLine[1:]
				mList.append(szAppendTemp+": "+actualLine)

			if (string.find(actualLine, szSeparator)!=-1):
				iCurrentRound+=1
				if (iRet==-1):
					if (fExt==self.XMLEXT):
						bAppendNext=True
						szAppendTemp = actualLine
					else:
						mList.append(actualLine)
				else:
					if (bDirect == True):
						bDirect = False
						bAll = False
					else:
						if (iCurrentRound == iRet):
							bDirect = True
							bAll = False
							self.startLineNumbering = iActualRow
			if (bDirect==True):
				mList.append(actualLine)
		if (bDirect==True):
			mList.append(self.EOFTEXT)
		if (bAll==True):
			for actualLine in linesFile:
				mList.append(actualLine)
			mList.append(self.EOFTEXT)
		return mList

	def apds(self, szWhere, szWhat, iWhich): # Let's add new line to pull down menu
		screen = self.getScreen()
		screen.addPullDownString(szWhere, szWhat, iWhich, iWhich, False)

	def ctr(self): # > codeTableReload
		self.codeTableReload()

	def codeTableReload(self): # Let's reload main codetable
		screen = self.getScreen()
		szTable = self.CODETABLE
		codeArea = self.CODE_PANEL_ID
		lv1ID = self.SELECT01ID
		lv2ID = self.SELECT02ID
		lv3ID = self.SELECT03ID
		lv4ID = self.SELECT04ID
		iLv1 = screen.getSelectedPullDownID(lv1ID) # get level01 menu item
		iLv2 = screen.getSelectedPullDownID(lv2ID) # get level02 menu item
		iLv3 = screen.getSelectedPullDownID(lv3ID) # get level03 menu item
		iLv4 = screen.getSelectedPullDownID(lv4ID) # get level04 menu item

		screen.deleteWidget(codeArea);
		screen.deleteWidget(szTable);

		screen.addPanel(codeArea, self.CODE_PANEL_LABEL, "", False, True, self.CODE_PANEL_X, self.CODE_PANEL_Y, self.CODE_PANEL_W, self.CODE_PANEL_H, PanelStyles.PANEL_STYLE_MAIN)

		screen.addTableControlGFC(szTable, 2, self.CODE_TABLE_X, self.CODE_TABLE_Y, self.CODE_TABLE_W, self.CODE_TABLE_H, False, False, 16, 16, TableStyles.TABLE_STYLE_STANDARD)
		screen.setTableColumnHeader(szTable, 0, "", self.CODE_TABLE_LINENUMBERCOLSIZE)
		screen.setTableColumnHeader(szTable, 1, "", self.CODE_TABLE_CODELINECOLSIZE)

		if (iLv4 == 1):  # SUMMARY screen
			self.ntl(szTable, "Summary:", None)
			if (self.selectedFile != ""):
				self.ntl(szTable, "File: "+self.selectedFile, None)
				self.ntl(szTable, "Size: "+self.prettySize(os.path.getsize(self.selectedFile)), None)
				self.ntl(szTable, "Permissions: "+"#todo", None)
				return 0


		fExamine = None
		fList = []

		iCountItem = 1

		#self.ntl(self.CODETABLE, "before if sq", None)
		### FC: target specific file
		if (iLv1==0): # >> None
			self.ntl(self.CODETABLE, "Everything is shiny ... :)", None)
			self.ntl(self.CODETABLE, "Select where to search", None)
		elif (iLv2==0): # >> None
			self.ntl(self.CODETABLE, "Everything is shiny ... :)", None)
			self.ntl(self.CODETABLE, "Be more specific in your selection", None)
		elif (iLv3==0): # >> None
			self.ntl(self.CODETABLE, "Everything is shiny ... :)", None)
			self.ntl(self.CODETABLE, "Some more details", None)
		elif (iLv1==1): # >> Files
			if (iLv2<(self.lastpy+1)): # >> Python
				if (iLv2==1): # >> Root
					# load root py files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if ((iCountItem) == iLv3): # examine all
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
				elif (iLv2==self.lastpy): # >> All
					# load all py files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-3):]
								if (f2Ext == self.PYEXT): # is this filename python file ??
									if (iCountItem == iLv3):
										fExamine = os.path.join(curr2Folder, f2Filename)
									iCountItem += 1
					if ((iCountItem) == iLv3): # examine all
						# load all py files
						# root files first
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
						# now folder by folder
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, fFilename ,None)
								f2Filename = fFilename
								curr2Folder = os.path.join(currFolder,f2Filename)
								file2List = os.listdir(curr2Folder)
								for f2Filename in file2List:
									f2Ext = f2Filename[(len(f2Filename)-3):]
									if (f2Ext == self.PYEXT): # is this filename python file ??
										fList.append(os.path.join(curr2Folder, f2Filename))
				else: # >> Regular folder
					# load py files from folder
					iCountItem = 1
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							iCountItem += 1
							if (iCountItem == iLv2):
								fDirectory = fFilename
								break;
					currFolder = os.path.join(currFolder,fDirectory)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder, fFilename)
							iCountItem += 1
					if (iCountItem==iLv3): # examine all
						iCountItem = 1
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								iCountItem += 1
								if (iCountItem == iLv2):
									fDirectory = fFilename
									break;
						currFolder = os.path.join(currFolder,fDirectory)
						fileList = os.listdir(currFolder)
						iCountItem = 1
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-3):]
							if (fExt == self.PYEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder, fFilename))
			elif (iLv2<(self.lastxml+1)): # >> XML
				if (iLv2==self.lastpy+1): # >> Root
					# load root xml files
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if (iCountItem == iLv3): # examine all
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename XML file ??
								fList.append(os.path.join(currFolder,fFilename))
				elif (iLv2==self.lastxml): # >> All
					# load all xml files
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-4):]
								if (f2Ext == self.XMLEXT): # is this filename XML file ??
									if (iCountItem == iLv3):
										fExamine = os.path.join(curr2Folder,f2Filename)
									iCountItem += 1
					if (iCountItem == iLv3):
						# load all xml files
						# root files first
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename XML file ??
								fList.append(os.path.join(currFolder,fFilename))
						# now folder by folder
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, fFilename ,None)
								f2Filename = fFilename
								curr2Folder = os.path.join(currFolder,f2Filename)
								file2List = os.listdir(curr2Folder)
								for f2Filename in file2List:
									f2Ext = f2Filename[(len(f2Filename)-4):]
									if (f2Ext == self.XMLEXT): # is this filename XML file ??
										fList.append(os.path.join(curr2Folder,f2Filename))

				else: # >> Regular folder
					# load xml files from folder
					iCountItem = 1
					iSearchFor = iLv2 - self.lastpy
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					#self.ntl(self.CODETABLE, "(iC)"+str(iCountItem)+"; (iS)"+str(iSearchFor), None)
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, str(iCountItem)+": "+fFilename, None)
							iCountItem += 1
							if (iCountItem == iSearchFor):
								#self.ntl(self.CODETABLE, "+1 is searched for", None)
								fDirectory = fFilename
								break;
					curr2Folder = os.path.join(currFolder,fDirectory)
					currFolder = curr2Folder
					#self.ntl(self.CODETABLE, currFolder, None)
					fileList = os.listdir(currFolder)
					iCountItem = 1
					for fFilename in fileList:
						#self.ntl(self.CODETABLE, "> "+fFilename, None)
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename python file ??
							if (iCountItem == iLv3):
								fExamine = os.path.join(currFolder,fFilename)
							iCountItem += 1
					if (iCountItem == iLv3): # examine all
						iCountItem = 1
						iSearchFor = iLv2 - self.lastpy
						currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
						fileList = os.listdir(currFolder)
						#self.ntl(self.CODETABLE, "(iC)"+str(iCountItem)+"; (iS)"+str(iSearchFor), None)
						for fFilename in fileList:
							if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
								#self.ntl(self.CODETABLE, str(iCountItem)+": "+fFilename, None)
								iCountItem += 1
								if (iCountItem == iSearchFor):
									#self.ntl(self.CODETABLE, "+1 is searched for", None)
									fDirectory = fFilename
									break;
						curr2Folder = os.path.join(currFolder,fDirectory)
						currFolder = curr2Folder
						#self.ntl(self.CODETABLE, currFolder, None)
						fileList = os.listdir(currFolder)
						for fFilename in fileList:
							#self.ntl(self.CODETABLE, "> "+fFilename, None)
							fExt = fFilename[(len(fFilename)-4):]
							if (fExt == self.XMLEXT): # is this filename python file ??
								fList.append(os.path.join(currFolder,fFilename))
			else: # >> All
				# load ALL XML and py files
				# load all py files first
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-3):]
					if (fExt == self.PYEXT): # is this filename python file ??
						if (iCountItem == iLv3):
							fExamine = os.path.join(currFolder,fFilename)
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-3):]
							if (f2Ext == self.PYEXT): # is this filename python file ??
								if (iCountItem == iLv3):
									fExamine = os.path.join(curr2Folder,f2Filename)
								iCountItem += 1
				self.lastpy2 = iCountItem
				# load all xml files now
				# root files first
				currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
				fileList = os.listdir(currFolder)
				for fFilename in fileList:
					fExt = fFilename[(len(fFilename)-4):]
					if (fExt == self.XMLEXT): # is this filename XML file ??
						if (iCountItem == iLv3):
							fExamine = os.path.join(currFolder,fFilename)
						iCountItem += 1
				# now folder by folder
				for fFilename in fileList:
					if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
						#self.ntl(self.CODETABLE, fFilename ,None)
						f2Filename = fFilename
						curr2Folder = os.path.join(currFolder,f2Filename)
						file2List = os.listdir(curr2Folder)
						for f2Filename in file2List:
							f2Ext = f2Filename[(len(f2Filename)-4):]
							if (f2Ext == self.XMLEXT): # is this filename XML file ??
								if (iCountItem == iLv3):
									fExamine = os.path.join(curr2Folder,f2Filename)
								iCountItem += 1
				self.lastxml2 = iCountItem
				if (iCountItem==iLv3):
					# load ALL XML and py files
					# load all py files first
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.PYFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-3):]
						if (fExt == self.PYEXT): # is this filename python file ??
							fList.append(os.path.join(currFolder,fFilename))
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-3):]
								if (f2Ext == self.PYEXT): # is this filename python file ??
									fList.append(os.path.join(curr2Folder,f2Filename))
									iCountItem += 1
					# load all xml files now
					# root files first
					currFolder = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER)
					fileList = os.listdir(currFolder)
					for fFilename in fileList:
						fExt = fFilename[(len(fFilename)-4):]
						if (fExt == self.XMLEXT): # is this filename XML file ??
							fList.append(os.path.join(currFolder,fFilename))
							iCountItem += 1
					# now folder by folder
					for fFilename in fileList:
						if (os.path.isdir(os.path.join(currFolder, fFilename))): # is this filename directory ??
							#self.ntl(self.CODETABLE, fFilename ,None)
							f2Filename = fFilename
							curr2Folder = os.path.join(currFolder,f2Filename)
							file2List = os.listdir(curr2Folder)
							for f2Filename in file2List:
								f2Ext = f2Filename[(len(f2Filename)-4):]
								if (f2Ext == self.XMLEXT): # is this filename XML file ??
									fList.append(os.path.join(curr2Folder,f2Filename))
									iCountItem += 1
		if (iLv1==2): # >> Entities
			self.ntl(self.CODETABLE, "Everything is shiny ... and this is not implemented ;)", None)

		### FC: target specific definition
		completeList = []
		tempList = []
		iGenC = iLv4-2
		if (iLv1==1):
			if (iGenC<0): # nothing selected
				self.ntl(self.CODETABLE, "So far no python error ... :)", None)
				return None
			if (fList!=[]): #if fList isn't empty
				#self.ntl(self.CODETABLE, "fList:", None)
				bSelected = false;
				for mItem in fList: # for every file in list of files
					if (self.applyExcludeList(mItem)!=None): # if file isnt excluded
						#self.ntl(self.CODETABLE, mItem, None)
						tempList = self.examineFile(mItem, self.getSeparator(mItem), -1) # get all code from it
						iGenC -= len(tempList) # subtract count of item from number of selection in menu
						if (iGenC < 0): # is it below zero ? then it contains our code
							iGenC += len(tempList) # revert subtracting ...
							completeList = self.examineFile(mItem, self.getSeparator(mItem), iGenC) # get actual code
							bSelected = true;
							break;
				if (bSelected == false): # nothing selected => get all
					completeList = []
					#completeList.append("getall: start");
					for mItem in fList: # for every file in list of files
						if (self.applyExcludeList(mItem)!=None): # if file isnt excluded
							#self.ntl(self.CODETABLE, mItem, None)
							#completeList.append("getall: nextitem")
							complete2List = self.examineFile(mItem, self.getSeparator(mItem), 32767) # get actual code
							for m2Item in complete2List: # copy it to global list
								completeList.append(m2Item)
			elif (fExamine!=None):
				self.selectedFile = fExamine
				if (self.applyExcludeList(fExamine)!=None): # isn't file excluded ?
					completeList = self.examineFile(fExamine, self.getSeparator(fExamine), iGenC) # get proper code
			else:
				None;
			### FC: just copy lines from list to codetable
			iCountItem = 1
		elif (iLv1==2): # >> Entities
			if (iLv2==1): # >> Units
				self.selectedFile = os.path.join(os.getcwd(),"Mods",self.MODNAME,self.ASSETFOLDER,self.XMLFOLDER, "Units\\CIV4UnitInfos.xml");
				fExamine = self.selectedFile
				completeList = self.examineFile(fExamine, self.getSeparator(fExamine), iGenC)

			None;
		for mItem in completeList:
			self.ntl(self.CODETABLE, self.handleTagBrace(mItem), self.startLineNumbering+iCountItem)
			#self.apds(selID, mItem, iCountItem)
			if (self.getPositionLastOccur(mItem, self.FILENAMESIGN)==-1):
				iCountItem += 1
			if (mItem == self.EOFTEXT): # end of file? reset row counter then
				iCountItem = 1

		self.ntl(self.CODETABLE, self.EORTEXT, iCountItem)
		return 0

	def handleTagBrace(self, szString): # civ4 strings use html formating, so we have to use html entities for "<" and ">"
		szTemp = szString
		iLeftB = 0
		iRightB = 0
		bDoIt = true;
		while (bDoIt):
			bDoIt = false;
			for i in range(len(szTemp)):
				if (szTemp[i]=="<"):
					szTemp=szTemp[:(i)]+"&#60;"+szTemp[(i+1):]
					iLeftB+=1
					bDoIt = true;
					break;
				if (szTemp[i]==">"):
					szTemp=szTemp[:(i)]+"&#62;"+szTemp[(i+1):]
					iRightB+=1
					bDoIt = true;
					break;
#		if (iLeftB==1):
#			szTemp = ""

		return szTemp

	def prettySize(self, size): # Convert bytes to some more prettier units
		suffixes = [("B",2**10), ("K",2**20), ("M",2**30), ("G",2**40), ("T",2**50)]
		for suf, lim in suffixes:
			if size > lim:
				continue
			else:
				return round(size/float(lim/2**10),2).__str__()+suf

	def ntl(self, szTable, szContent, iLine): # > newTableLine
		self.newTableLine(szTable, szContent, iLine)

	def newTableLine(self, szTable, szContent, iLine): # add line to codetable
		screen = self.getScreen()
		iRow = screen.appendTableRow(szTable)
		if (iLine == None):
			screen.setTableText(szTable, 0, iRow, self.addZeroBefore(iRow),"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY)
		elif ((szContent == self.EOFTEXT) or (szContent == self.EORTEXT)):
			screen.setTableText(szTable, 0, iRow, self.addZeroBefore(-1),"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY)
		elif (self.getPositionLastOccur(szContent, self.FILENAMESIGN)!=-1):
			screen.setTableText(szTable, 0, iRow, self.addZeroBefore(-1),"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY)
		else:
			screen.setTableText(szTable, 0, iRow, self.addZeroBefore(iLine),"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY)
		if (self.getPositionLastOccur(szContent, self.FILENAMESIGN)!=-1):
			screen.setTableText(szTable, 1, iRow, self.TEXTFORMATBEGIN + self.FILENAMETEXT + szContent[(len(self.FILENAMESIGN)):] + self.TEXTFORMATEND,"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		elif ((szContent == self.EOFTEXT) or (szContent == self.EORTEXT)):
			screen.setTableText(szTable, 1, iRow, self.TEXTFORMATBEGIN+ szContent + self.TEXTFORMATEND,"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		elif (self.getPositionLastOccur(szContent, "def ")!=-1):
			screen.setTableText(szTable, 1, iRow, self.DEFHIGHBEGIN+ szContent + self.DEFHIGHEND,"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)
		else:
			screen.setTableText(szTable, 1, iRow, szContent,"", WidgetTypes.WIDGET_GENERAL, -1, -1, CvUtil.FONT_LEFT_JUSTIFY)



	def addZeroBefore(self, iNum): # add zeroes before number
		szNum = str(iNum)
		if iNum < 0:
			szNum = "xxxxxxx"
			return szNum
		if iNum < 10:
			szNum = "0"+szNum
		if iNum < 100:
			szNum = "0"+szNum
		if iNum < 1000:
			szNum = "0"+szNum
		if iNum < 10000:
			szNum = "0"+szNum
		if iNum < 100000:
			szNum = "0"+szNum
		return szNum
